# convolve 2 arrays of max size 32 using the multiplier/accumulator

lbl('convolve_a'); data([0]) # array adr
lbl('convolve_b'); data([0]) # array adr
lbl('convolve_r'); data([0]) # normalized macc result adr
lbl('convolve_s'); data([0]) # size

lbl('convolve') # size result_adr b_adr a_adr -> sop
# return a normalized convolution of sized arrays a X b
  lst(convolve_a); lst(convolve_b); lst(convolve_r); lst(convolve_s) # ->
  lit(0); tt(); lst(rnd_sop) # -> index
lbl('convolve_loop')
    tt(); lld(convolve_s); bxor(); ljz(fwd('convolve_done'))
      tt(); lld(convolve_a); ald(); lst(mfa)
      tt(); lld(convolve_b); ald(); lst(mfb)
      tt(); lst(acc_sop)
      inc() # -> index'
      ljmp(convolve_loop)
lbl('convolve_done')
  drop() # ->
  lld(convolve_r); ld(); ret() # -> sop
