# MCP3208 12-bit ADC SPI interface using single-ended analog inputs
# requires lib/spi.py

def12('mcp3208_speed', 17 << 3) # 1 MHz sck, upper 5-bit field for lst(spi_ctl)

lbl('mcp3208_acquire') # analog_channel spi_select -> d
# acquire channel 0..7 from selected device 1..7
  lbxor(mcp3208_speed); lst(spi_ctl) # -> analog_channel
  tt(); asr(); asr(); lbxor(6); lst(spi) # tx 0,0,0,0,0,1,1,ch[2]
  lst(mfa); lit(64), lst(mfb); lld(prod11) # -> ch[1:0]<<6
  lcall(spi_wait)
  lst(spi) # -> # tx ch[1],ch[0],0,0,0,0,0,0
  lcall(spi_wait)
  lld(spi) # -> adc[11:8]
  lit(0); lst(spi) # tx dummy
  lband(15); lst(mfa); lit(256); lst(mfb); lld(prod11) # -> adc[11:8]<<8
  lcall(spi_wait)
  lld(spi); bxor() # -> adc[11:0]
  lit(0); lst(spi_ctl); ret() # deselect
