// rising edge write, falling edge read, 12 bits, 4K, preloaded with external file ram.hex

module ram (
  input clk_i,
  input sel_i,
  input [11:0] adr_i,
  input storex_i,
  input [11:0] dat_i,
  output [11:0] dat_o
);

reg [11:0] ram [0:4095];
initial $readmemh("C:/Users/myron/Desktop/TigerSBC/FPGAburn/ram.hex", ram);
always @(posedge clk_i) if (sel_i & storex_i) ram[adr_i] <= dat_i;
reg [11:0] read_data;
always @(negedge clk_i) read_data <= ram[adr_i];
assign dat_o = sel_i ? read_data : 0; // ORable

endmodule
