include('FPGAburn/appload.py') # must be on the first line

# test bit-banging functions by observing red led D7

  ljmp(fwd('init')) # at app_start

# keystroke command procedures

lbl('got_on') # keystroke ->
# turn on D7
  drop() # ->
  lit(1); lst(po); ret()

lbl('got_off') # keystroke ->
# turn off D7
  drop() # ->
  lit(0); lst(po); ret()

lbl('got_set') # keystroke ->
# turn on D7
  drop() # ->
  lit(1); lst(pos); ret()

lbl('got_clr') # keystroke ->
# turn off D7
  drop() # ->
  lit(1); lst(poc); ret()

lbl('got_inv') # keystroke ->
# invert D7
  drop() # ->
  lit(1); lst(poi); ret()

lbl('command') # ->
# respond to USB/UART keystrokes
  lld(rx_status); ljz(fwd('no_command'))
    lld(uart) # -> keystroke
    tt(); lcall(tx) # echo
    # resolve defined keystroke commands
    tt(); lbxor(ord('1')); ljz(got_on)
    tt(); lbxor(ord('0')); ljz(got_off)
    tt(); lbxor(ord('s')); ljz(got_set)
    tt(); lbxor(ord('c')); ljz(got_clr)
    tt(); lbxor(ord('i')); ljz(got_inv)
    drop() # -> # none of the above, drop keystroke
lbl('no_command')
  ret()

# the app

lbl('init') # from app_start
  # nothing to init
lbl('doit')
    lcall(command)
    ljmp(doit)

lbl('app_end') # must be on the last line
