include('FPGAburn/appload.py') # must be on the first line

# test the convolve procedure

  ljmp(fwd('init'))

include('lib/convolve.py')
include('lib/hexio.py')

def12('points', 32)
def12('norm', norm32)

lbl('cos'); data([int(MAXPOS*math.cos(n*math.tau/points)) for n in range(points)])
lbl('sin'); data([int(MAXPOS*math.sin(n*math.tau/points)) for n in range(points)])
lbl('bad'); data([0x800 for n in range(points)])
lbl('goo'); data([0x800 for n in range(points-1)]); data([0x801])
lbl('min'); data([0x801 for n in range(points)])
lbl('max'); data([0x7ff for n in range(points)])
lbl('sqw'); data([0x7ff for n in range(points>>1)]); data([0x801 for n in range(points>>1)])

# keystroke command procedures

lbl('printf') # d ->
# space, hex, newline
  lcall(sp); lcall(printx); ljmp(cr)

lbl('ccos') # keystroke ->
# convolve cos X cos, print
  drop() # ->
  lit(points); lit(norm); lit(cos); tt(); lcall(convolve); ljmp(printf)

lbl('csin') # keystroke ->
# convolve sin X sin, print
  drop() # ->
  lit(points); lit(norm); lit(sin); tt(); lcall(convolve); ljmp(printf)

lbl('cbad') # keystroke ->
# convolve bad X bad, print
  drop() # ->
  lit(points); lit(norm); lit(bad); tt(); lcall(convolve); ljmp(printf)

lbl('cgoo') # keystroke ->
# convolve goo X bad, print
  drop() # ->
  lit(points); lit(norm); lit(goo); lit(bad); lcall(convolve); ljmp(printf)

lbl('cmin') # keystroke ->
# convolve min X min, print
  drop() # ->
  lit(points); lit(norm); lit(min); tt(); lcall(convolve); ljmp(printf)

lbl('cmax') # keystroke ->
# convolve max X max, print
  drop() # ->
  lit(points); lit(norm); lit(max); tt(); lcall(convolve); ljmp(printf)

lbl('csqw') # keystroke ->
# convolve sqw X sqw, print
  drop() # ->
  lit(points); lit(norm); lit(sqw); tt(); lcall(convolve); ljmp(printf)

lbl('command') # ->
# respond to USB/UART keystrokes
  lld(rx_status); ljz(fwd('no_command'))
    lld(uart) # -> keystroke
    tt(); lcall(tx) # echo
    # resolve defined keystroke commands
    tt(); lbxor(ord('c')); ljz(ccos)
    tt(); lbxor(ord('s')); ljz(csin)
    tt(); lbxor(ord('b')); ljz(cbad)
    tt(); lbxor(ord('g')); ljz(cgoo)
    tt(); lbxor(ord('m')); ljz(cmin)
    tt(); lbxor(ord('M')); ljz(cmax)
    tt(); lbxor(ord('2')); ljz(csqw)
    drop() # -> # none of the above, drop keystroke
lbl('no_command')
  ret()

# the app

lbl('init')
  #
lbl('doit')
    lcall(command)
    ljmp(doit)

lbl('app_end') # must be on the last line
