include('FPGAburn/appload.py') # must be on the first line

# test drive an MCP3208, namely spi_adc1
# report the selected ADC channel as unsigned hex

  ljmp(fwd('init'))

include('lib/spi.py')
include('lib/mcp3208.py')
include('lib/hexio.py')

# prompts
lbl('channel_prompt'); ascii('\r\nADC channel? ')

# titles
lbl('result_title'); ascii('\r\nresult is ')
lbl('time_title'); ascii('\r\nelapsed clocks was ')

# re elapsed clocks
lbl('profile_start'); data([0])
lbl('profile_end'); data([0])

lbl('init')
  # nothing to init
lbl('doit')
    # get adc channel
    lit(channel_prompt); lcall(prompt_for) # -> channel
    # start time
    lld(t11); lst(profile_start)
    # what to time
    lit(spi_adc1); lcall(mcp3208_acquire); # -> d
    # end time
    lld(t11); lst(profile_end)
    # print result
    lit(result_title); lcall(print_titled) # ->
    # print elapsed clocks
    lld(profile_end); lld(profile_start); sub() # -> dt
    lit(time_title); lcall(print_titled) # ->
    #
    lcall(cr); ljmp(doit)

lbl('app_end') # must be on the last line