include('FPGAburn/appload.py') # must be on the first line

# test drive an MCP4921 12-bit SPI DAC, namely spi_dac1
# observe Vout with a DMM on the selected DAC's pin 8

  ljmp(fwd('init'))

include('lib/spi.py')
include('lib/mcp4921.py')
include('lib/hexio.py')

# prompts
lbl('dac_prompt'); ascii('\r\nDAC value? ')

# titles
lbl('time_title'); ascii('\r\nelapsed clocks was ')

# re elapsed clocks
lbl('profile_start'); data([0])
lbl('profile_end'); data([0])

lbl('init')
  # nothing to init
lbl('doit')
    # get dac value
    lit(dac_prompt); lcall(prompt_for) # -> d
    # start time
    lld(t11); lst(profile_start)
    # what to time
    lit(spi_dac1); lcall(mcp4921_update); # ->
    # end time
    lld(t11); lst(profile_end)
    # print elapsed clocks
    lld(profile_end); lld(profile_start); sub() # -> dt
    lit(time_title); lcall(print_titled) # ->
    #
    lcall(cr); ljmp(doit)

lbl('app_end') # must be on the last line
