# MCP4921 12-bit DAC SPI interface
# requires lib/spi.py

def12('mcp4921_speed', 0 << 3) # 18 MHz sck, upper 5-bit field for lst(spi_ctl)

lbl('mcp4921_update') # d spi_select ->
# tx d to selected device 1..7
  lbxor(mcp4921_speed); lst(spi_ctl) # -> d
  tt(); asr(); asr(); asr(); asr(); asr(); asr(); asr(); asr(); lband(15) # -> d d[11:8]>>8
  lbxor(0x30); lst(spi) # -> d # tx 0,0,1,1,d[11:8]
  lcall(spi_wait)
  lst(spi) # -> # tx d[7:0]
  lcall(spi_wait)
  lit(0); lst(spi_ctl); ret() # deselect
