# return cos or sin of phase
# phase arguments are unsigned, analogous to 0..2pi

lbl('sine_lut'); data([int(MAXPOS*math.sin(n*math.tau/2048)) for n in range(2048)])

lbl('cos') # phase -> amplitude
  ladd(SIGNBIT>>1) # a quarter turn
# drop through
lbl('sin') # phase -> amplitude
  asr(); lband(2047); lald(sine_lut); ret()
